{{>licenseInfo}}

import http from "k6/http";
import { group, check, sleep } from "k6";

import { authenticateUsingKeycloak } from {{{keycloakScriptPath}}};

const BASE_URL = __ENV.ENVIRONMENT_URL;

// Options
// For more info, see: 
//  * https://k6.io/docs/test-types/load-testing/
//  * https://k6.io/docs/getting-started/running-k6/#stages-ramping-up-down-vus
export let options = {
  stages: [
    // Ramp-up from 1 to 10 VUs in 1m
    { duration: "1m", target: 10 },

    // Stay at rest on 20 VUs for 1m
    { duration: "1m", target: 20 },

    // Ramp-down from 20 to 0 VUs in 1m
    { duration: "1m", target: 0 }
  ], 
  thresholds: { 
    http_req_duration: ['avg<1000', 'p(95)<1500'] // on average requests must complete below 1s; 95% of requests must complete below 1.5s;
  }
};

// Sleep duration between successive requests.
// You might want to edit the value of this variable or remove calls to the sleep function on the script.
const SLEEP_DURATION = 0.2;
// Global variables should be initialized.
{{#extra}}
let {{{key}}} = "TODO_EDIT_THE_{{{value}}}";
{{/extra}}

export function setup() {
  let passwordAuthResp = authenticateUsingKeycloak(__ENV.KEYCLOAK_ADDRESS, __ENV.KEYCLOAK_USESSL, __ENV.KEYCLOAK_REALM, __ENV.KEYCLOAK_CLIENT_ID, __ENV.KEYCLOAK_CLIENT_SECRET, __ENV.KEYCLOAK_SCOPES, {
    username: __ENV.USERNAME,
    password: __ENV.PASSWORD,
  });
  
  return passwordAuthResp;
}

export default function (data) {

    let params = {
        headers: {
            Authorization: `Bearer ${data.access_token}`,
            Accept: 'application/json',
            'Content-Type': 'application/json'
        },
    };

    {{#requestGroups}}
    group("{{{groupName}}}", () => {
        {{#variables}}
        let {{{key}}} = {{#lambda.handleParamValue}}{{value}}{{/lambda.handleParamValue}}
        {{/variables}}
        {{#requests}}
        
        // Request No. {{-index}}
        {
          let url = BASE_URL + `{{{path}}}{{=<% %>=}}<%#query%><%#-first%>?<%/-first%><%& key%>=<%& value%><%^-last%>&<%/-last%><%/query%><%={{ }}=%>`;
          
          {{#body}}
          {{^hasBodyExample}}
          // TODO: edit the parameters of the request body.
          {{/hasBodyExample}}
          let body = {{#body}}{{=<% %>=}}{<%#parameters%>"<%& key%>": <%& value%><%^-last%>, <%/-last%><%/parameters%>}<%={{ }}=%>{{/body}};
          {{/body}}
          
          {{#isDelete}}
          let request = http.{{method}}(url, {}, params);
          {{/isDelete}}
          {{^isDelete}}
          let request = http.{{method}}(url{{#body}}, JSON.stringify(body){{/body}}, params);
          {{/isDelete}}
                
          {{#k6Checks}}
          {{=<% %>=}}
          check(request, {
            "<%& description%>": (r) => r.status === <%& status%>
          });
          <%={{ }}=%>
          {{/k6Checks}}
          
          {{#dataExtract}}
          {{{paramName}}} = JSON.parse(request.body).{{{valuePath}}}; // extract data for subsequent use
          {{/dataExtract}}
          
          {{^-last}}
          sleep(SLEEP_DURATION);
          {{/-last}}
        }
        {{/requests}}
    });
    {{/requestGroups}}
}